#include <iostream>
#include <future>
#include <mutex>
#include <vector>
#include <thread>

using namespace std;
using namespace std::chrono;

class CountingThreads {
	public:
		CountingThreads() { }
		void run() {
			uint32_t numThreads = thread::hardware_concurrency();
			for (uint32_t t = 0; t < numThreads; ++t)	{
				promise<unsigned long> prom;
				future<unsigned long> futVal = prom.get_future();
				future<unsigned long> retVal = async(launch::async, &CountingThreads::countTask, this, ref(futVal));
				this_thread::sleep_for(seconds(t));
				prom.set_value(t);
				cout<<"thread "<<t<<" returned value "<<retVal.get()<<endl;
			}
		}
	private:
		unsigned long countTask(future<unsigned long>& futVal)	{
			uint32_t threadId = futVal.get();
			return 10u*threadId;
		}
};

int main()	{
	CountingThreads ct;
	ct.run();
	return 0;
}

